﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#IgnoreWarnings: 12
'Class module
Sub Class_Globals
	Private JO As JavaObject
End Sub

'We always need to initialize the JOWrapper, there are no arguments it just runst the internal initialization
Public Sub Initialize
	
End Sub

'Create a new class with no arguments and returns the JOWrapper object
Public Sub New(ClassName As String) As JOWrapper
	JO.InitializeNewInstance(ClassName, Null)
	Return Me
End Sub
'Create a new class with 2 argument and returns the JOWrapper object
Public Sub New1(ClassName As String, Param As Object) As JOWrapper
	JO.InitializeNewInstance(ClassName, Array As Object(UnWrap(Param)))
	Return Me
End Sub
'Create a new class with 2 arguments and returns the JOWrapper object
Public Sub New2(ClassName As String, Param1 As Object,Param2 As Object) As JOWrapper
	JO.InitializeNewInstance(ClassName, Array As Object(UnWrap(Param1),UnWrap(Param2)))
	Return Me
End Sub
'Create a new class with 3 arguments and returns the JOWrapper object
Public Sub New3(ClassName As String, Param1 As Object,Param2 As Object,Param3 As Object) As JOWrapper
	JO.InitializeNewInstance(ClassName, Array As Object(UnWrap(Param1),UnWrap(Param2),UnWrap(Param3)))
	Return Me
End Sub
'Create a new class with an array arguments and returns the JOWrapper object
Public Sub NewMulti(ClassName As String, Params() As Object) As JOWrapper
	For i = 0 To Params.Length - 1
		Params(i) = UnWrap(Params(i))
	Next
	JO.InitializeNewInstance(ClassName, Params)
	Return Me
End Sub

'Create an object to access a static class
Public Sub Static(ClassName As String) As JavaObject
	Return JO.InitializeStatic(ClassName)
End Sub

'Run a method on a Class with no arguments, returns the return value from the method as an object
Public Sub RM(Method As String) As Object
	Return JO.RunMethod(Method,Null)
End Sub
'Run a method on a Class with 1 argument, returns the return value from the method as an object
Public Sub RM1(Method As String, Param As Object) As Object
	Return JO.RunMethod(Method,Array As Object(UnWrap(Param)))
End Sub
'Run a method on a Class with 2 arguments, returns the return value from the method as an object
Public Sub RM2(Method As String, Param1 As Object, Param2 As Object) As Object
	Return JO.RunMethod(Method, Array As Object(UnWrap(Param1),UnWrap(Param2)))
End Sub
'Run a method on a Class with 3 arguments, returns the return value from the method as an object
Public Sub RM3(Method As String,Param1 As Object,Param2 As Object,Param3 As Object) As Object
	Return JO.RunMethod(Method,Array As Object(UnWrap(Param1),UnWrap(Param2),UnWrap(Param3)))
End Sub
'Run a method on a Class with an array of arguments, returns the return value from the method as an object
Public Sub RMMulti(Method As String,Params() As Object) As Object
	For i = 0 To Params.Length - 1
		Params(i) = UnWrap(Params(i))
	Next
	Return JO.RunMethod(Method,Params)
End Sub

'Run a method on a Class with no arguments, returns a JOWrapper object to allow chaining of methods
Public Sub RMW(Method As String) As JOWrapper
	Dim Result As JOWrapper
	Result.Initialize
	Result.SetObject(JO.RunMethod(Method,Null))
	Return Result
End Sub
'Run a method on a Class with 1 argument, returns a JOWrapper object to allow chaining of methods
Public Sub RMW1(Method As String,Param As Object) As JOWrapper
	Dim Result As JOWrapper
	Result.Initialize
	Result.SetObject(JO.RunMethod(Method,Array As Object(UnWrap(Param))))
	Return Result
End Sub
'Run a method on a Class with 2 arguments, returns a JOWrapper object to allow chaining of methods
Public Sub RMW2(Method As String,Param1 As Object,Param2 As Object) As JOWrapper
	Dim Result As JOWrapper
	Result.Initialize
	Result.SetObject(JO.RunMethod(Method, Array As Object(UnWrap(Param1),UnWrap(Param2))))
	Return Result
End Sub
'Run a method on a Class with 3 arguments, returns a JOWrapper object to allow chaining of methods
Public Sub RMW3(Method As String,Param1 As Object,Param2 As Object,Param3 As Object) As JOWrapper
	Dim Result As JOWrapper
	Result.Initialize
	Result.SetObject(JO.RunMethod(Method,Array As Object(UnWrap(Param1),UnWrap(Param2),UnWrap(Param3))))
	Return Result
End Sub
'Run a method on a Class with an object array of arguments, returns a JOWrapper object to allow chaining of methods
Public Sub RMWMulti(Method As String,Params() As Object) As JOWrapper
	For i = 0 To Params.Length - 1
		Params(i) = UnWrap(Params(i))
	Next
	Dim Result As JOWrapper
	Result.Initialize
	Result.SetObject(JO.RunMethod(Method,Params))
	Return Result
End Sub

'Run a method on a Class with no arguments, returns the return value from the method as a javaObject to allow further use of javaObject methods
Public Sub RMJO(Method As String) As JavaObject
	Return JO.RunMethodJO(Method,Null)
End Sub
'Run a method on a Class with 1 argument, returns the return value from the method as a javaObject to allow to allow further use of javaObject methods
Public Sub RMJO1(Method As String,Param As Object) As JavaObject
	Return JO.RunMethodJO(Method,Array As Object(UnWrap(Param)))
End Sub
'Run a method on a Class with 2 arguments, returns the return value from the method as a javaObject to allow to allow further use of javaObject methods
Public Sub RMJO2(Method As String,Param1 As Object,Param2 As Object) As JavaObject
	Return JO.RunMethodJO(Method, Array As Object(UnWrap(Param1),UnWrap(Param2)))
End Sub
'Run a method on a Class with 3 arguments, returns the return value from the method as a javaObject to allow to allow further use of javaObject methods
Public Sub RMJO3(Method As String,Param1 As Object,Param2 As Object,Param3 As Object) As JavaObject
	Return JO.RunMethodJO(Method,Array As Object(UnWrap(Param1),UnWrap(Param2),UnWrap(Param3)))
End Sub
'Run a method on a Class with an object array of arguments, returns the return value from the method as a javaObject to allow further use of javaObject methods
Public Sub RMJOMulti(Method As String,Params() As Object) As JavaObject
	For i = 0 To Params.Length - 1
		Params(i) = UnWrap(Params(i))
	Next
	Return JO.RunMethodJO(Method,Params)
End Sub

'Get the underlying JavaObject
Public Sub GetObject As JavaObject
	Return JO
End Sub

'Directly set an object for this JOWrapper
Public Sub SetObject(JObj As JavaObject) As JOWrapper
	JO = JObj
	Return Me
End Sub

'Get a field from the object and return as object
Sub GF(Name As String) As Object
	Return JO.GetField(Name)
End Sub

'Get a field from the object and return as javaObject
Sub GFJO(Name As String) As JavaObject
	Return JO.GetField(Name)
End Sub

'Get a field from the object and return as JOWrapper Object
Sub GFW(Name As String) As JOWrapper
	Dim W As JOWrapper
	W.Initialize
	W.SetObject(JO.GetField(Name))
	Return W
End Sub

'Set a Field in the Object. If a JOWrapper is passed, it will be unwrapped first
Sub SF(Name As String,Value As Object)
	JO.SetField(Name,UnWrap(Value))
End Sub


'Used to unwrap JOWrapper objects so the calls parameters have the correct signatures
Private Sub UnWrap(Obj As Object) As Object
	'Unwrap an array of JOWrapper objects passed as one element, and pass it back as a new array or the contained type
	Dim Test As String = GetType(Obj)
	If Test.StartsWith("[") And Test.EndsWith(GetType(Me) & ";") Then
		
		'Initialze a JavaObject so we can call the javacode in the java block
		Dim MeJo As JavaObject = Me
		
		'Get the first parameter from the array so we can determine the type of the variable
		Dim ObjArr() As Object = Obj
		Dim Obj1 As JOWrapper = ObjArr(0)
		
		'Create an array with the correct variable type
		MeJo.RunMethod("createArray",Array(GetType(Obj1.GetObject),ObjArr))
	
		'Populate the new array
		Dim i As Int
		For i = 0 To ObjArr.Length - 1
			Dim Obj1 As JOWrapper = ObjArr(i)
			MeJo.RunMethod("setElement",Array(i,Obj1.GetObject))
		Next
		
		'Return the new array of unwrapped objects with the correct type
		Return MeJo.RunMethod("getArray",Null)
	End If
	
	'Unwrap a single element
	If Obj Is JOWrapper Then
		Dim Obj1 As JOWrapper = Obj
		Return Obj1.GetObject
	End If
	
	'Pass back an unwrapped object
	Return Obj
End Sub


#if java

	import java.lang.reflect.Array;
	
	Object newArray = null;

	//Create a new array via reflection as we don't know what type the array will be beforehand
	
	public void createArray(String className, Object[] oldArray){
		try{
			Class<?> c = Class.forName(className);
			newArray = Array.newInstance(c , oldArray.length);
		} catch (ClassNotFoundException x){
			ba.Log("Class Not Found " + className);
		}
	}
	
	//Set an element in the array
	public Object setElement(int index,Object element){
		Array.set(newArray,index,element);
		return newArray;
	}

	//Get the Array
	public Object getArray(){
		return newArray;
	}
#end if
